--- new_window.c	2005-11-04 05:20:00.000000000 -0500
+++ new_window.c	2014-12-27 05:17:38.000000000 -0500
@@ -47,4 +47,6 @@
  */
 #include <stdio.h>
+#include <stdlib.h>
+#include <sys/wait.h>
 #include <X11/Xlib.h>
 #include <X11/Xutil.h>
@@ -60,5 +62,7 @@
 #include "xcoral.h"
 #include "new_window.h"
+#include "page.h"
 #include "parse.h"
+#include "ie_func.h"
 #include "list_box.h"
 #include "browser_init.h"
@@ -70,4 +74,7 @@
 #include "macros.h"
 #include "buttons_bits.h"
+#include "tbox.h"
+#include "text_cursor.h"
+#include "Smac/smacXcoral.h"
 
 extern Trans st_initial;
@@ -91,8 +98,8 @@ void InitIconPixmap()
   
   if ((depth == 16)||(depth == 24)) {
-    logo_image = (XImage *)LoadImage256 ((char **)xpm_logo);
+    logo_image = LoadImage256 (xpm_logo);
     xcoral_icon = XCreatePixmap (dpy, DefaultRootWindow(dpy), 32, 32,depth);
     xcoral_icon_mask = XCreatePixmapFromBitmapData ( dpy, DefaultRootWindow (dpy), 
-						    logo_bits, 32, 32,
+						    (char *)logo_bits, 32, 32,
 						    BlackPixel(dpy, DefaultScreen(dpy)),
 						    WhitePixel(dpy, DefaultScreen(dpy)), 1 );
@@ -335,5 +342,5 @@ void DisplayOpenFiles ( text )
     ClearListBox ();
     OpenFilesInListBox ();
-    tmp = (char *) SelectFromListBox ( "Open Files" );
+    tmp = SelectFromListBox ();
     if ( tmp != 0 ) {
 	/* str [2] = 0; */
@@ -360,39 +367,10 @@ void DisplayOpenFiles ( text )
 **	Description : Pour eviter les ouvertures multiples
 **		de fichiers
-**	Input : Le nom du fichier.
-**	Ouput : Le nombre de buffer ouvert sur le fichier.
-*/
-int OldIsAlreadyLoad ( s, text )
-    char *s;
-    Text **text;
-{
-    EdWin **t;
-    Text *tmp = 0;
-    int n = 0;
-    
-    for ( t = TWin; t < TWin + MAXWIN; t++ ) {
-	if ( *t == 0 )
-	  continue;
-	if ( strcmp ( s, (*t) -> text -> filename ) == 0 ) {
-	    n++;
-	    if ( ! tmp )
-	      tmp = (*t) -> text;
-	}
-    }
-    if ( tmp )
-      *text = tmp;
-    return n;
-}
-/*
-**	Function name : IsAlreadyLoad
-**
-**	Description : Pour eviter les ouvertures multiples
-**		de fichiers
 **	Input : Le contexte d'origine.
 **	Ouput : Le nombre de buffer ouvert sur le fichier.
 */
 int IsAlreadyLoad ( filename, from_text, text )
-    char *filename;
-    Text *from_text;
+    const char *filename;
+    const Text *from_text;
     Text **text; /* Return */
 {
@@ -480,8 +458,8 @@ int DeleteWindow ( text )
     }
     if ( tmp -> text -> shell_id != 0 ) {
-      int statusp, pid;
+      int statusp;
       void CleanFd();
       (void) kill ( tmp -> text -> shell_id, SIGKILL );
-      pid = wait ( &statusp );
+      wait ( &statusp );
       (void) CleanFd ( tmp -> text ); 
     }
@@ -561,6 +539,5 @@ int IsLastWindow ( nb )
 **	Ouput :
 */
-void Version ( text )
-    Text *text;
+void Version ()
 {
     char tmp [64];
@@ -578,6 +555,5 @@ void Version ( text )
 **	Ouput :
 */
-void Help ( text )
-    Text *text;
+void Help ()
 {
     DisplayManBox ();
@@ -594,10 +570,10 @@ void Hanoi ( text )
     Text *text;
 {
-  char *msg;
+  const char *msg;
   int nw = text->win_id;
   int tn = 5; /* Nombre de tours */
 
   StorePosition ( text );
-  msg = (char *) ie_call_function ( text, "hanoi", 1, &tn) ;
+  msg = ie_call_function ( text, "hanoi", 1, &tn) ;
   text = update_cwd(nw);
   if ( msg != 0 )
--- new_window.h	1998-10-16 07:02:15.000000000 -0400
+++ new_window.h	2014-12-26 23:53:28.000000000 -0500
@@ -45,14 +45,14 @@
 
 FCT (void, ConfigWindow, (EdWin *e, int width, int height) );
-FCT (EdWin *, CreateWindow, () );
+FCT (EdWin *, CreateWindow, (void) );
 FCT (int, DeleteWindow, (Text *text) );
 FCT (void , DisplayOpenFiles, (Text *text) );
-FCT (void , InitIconPixmap, () );
-FCT (void , Help, (Text *text) );
+FCT (void , InitIconPixmap, (void) );
+FCT (void , Help, (void) );
 FCT (void , Hanoi, (Text *text) );
-FCT (int, IsAlreadyLoad, (char *s, Text *from_text, Text **text) );
+FCT (int, IsAlreadyLoad, (const char *fname, const Text *from_text, Text **text) );
 FCT (int, IsLastWindow, (int nb) );
 FCT (void , NewWindow, (Text *text) );
-FCT (void , Version, (Text *text) );
+FCT (void , Version, (void) );
 
 #endif /* _NEW_WINDOW_H_ */
--- page.c	2002-09-03 08:23:11.000000000 -0400
+++ page.c	2014-12-27 01:37:45.000000000 -0500
@@ -46,4 +46,5 @@
 #include <sys/time.h>
 #include <stdlib.h>
+#include <string.h>
 
 #include "main_text.h"
@@ -54,4 +55,5 @@
 #include "color_area.h"
 #include "selection.h"
+#include "chars_cmds.h"
 
 extern Display *dpy;
@@ -240,5 +242,5 @@ void SetLinesTable ( text )
 {
     int line, n = 0, wl = 1;
-    char *s = 0, *hs;
+    char *s = NULL, *hs;
     int len;
     
@@ -251,5 +253,5 @@ void SetLinesTable ( text )
     for ( line = text -> n1; line > 0 ; line-- ) {
 	if (! s)
-	  s = ( char * ) GetBackwardLine ( text -> buf, -line, &len );
+	  s = GetBackwardLine(text -> buf, -line, &len);
 	else
 	  while (*s++ != '\n')
@@ -258,5 +260,5 @@ void SetLinesTable ( text )
 	    if ( text -> sl ) {
 	      hs = s;
-	      s = HscrollString ( s, text );
+	      s = HscrollString(s, text);
 	      text -> page.hs_dl [wl] = s - hs;
 	    }
@@ -278,7 +280,7 @@ void SetLinesTable ( text )
     for ( line = 0; line < text -> n2 + 1 + n; line++ ) {
 	if ( line == 0 )
-	  s = ( char * ) GetCurrentLine ( text -> buf, &len );
+	  s = GetCurrentLine ( text -> buf, &len );
 	else if (line == 1)
-	  s = ( char * ) GetForwardLine ( text -> buf, line, &len );
+	  s = GetForwardLine ( text -> buf, line, &len );
 	else {
 	  if (s) {
@@ -447,5 +449,6 @@ static int DrawLineOfText ( text, li )
 {
     int n = 1;  /* Caracteres en cours de traitement    */
-    char  *p, *s, *pp, *ppp;
+    const char *s;
+    char *p, *pp, *ppp;
     int xx, width, count, binary_flag = False;
 /*    int sizetab = text -> tab_width * text -> blanc_width; */
@@ -864,6 +867,5 @@ static void ScrollUpFewLines ( text, n )
     Buf *buf;
     int len;
-    int sel_was_visible = SelectionIsVisible(text);
-    
+
     buf = text -> buf;
 #ifdef DEBUG
@@ -924,6 +926,5 @@ static void ScrollDownFewLines ( text, n
     Buf *buf;
     int len;
-    int sel_was_visible = SelectionIsVisible(text);
-    
+
     buf = text -> buf;
 #ifdef DEBUG
@@ -1430,14 +1431,13 @@ char *CurrentTextItem ( text )
 {
     int len;
-    char *str, *tmp;
+    char *str;
+    const char *tmp;
     
-    tmp = (char *) GetCurrentLine ( text -> buf, &len );
-    if ( (tmp == 0) || (len == 0) )
+    tmp = GetCurrentLine (text -> buf, &len);
+    if ( (tmp == NULL) || (len == 0) )
       return 0;
-    tmp [len] = 0;
-    str = (char *) malloc ( (unsigned) len + 2 );
-    (void) sprintf ( str, "%s", tmp );
+    str = malloc(len + 1);
+    sprintf(str, "%.*s", len, tmp);
     return (str);
-    
 }
 
--- page.h	1995-02-22 08:03:39.000000000 -0500
+++ page.h	2014-12-26 23:51:34.000000000 -0500
@@ -78,5 +78,5 @@ FCT (void, UpdateTextItem, (Text *text, 
 FCT (void, WatchOff, (Window win) );
 FCT (void, WatchOn, (Window win) );
-FCT (void, klaxon, () );
+FCT (void, klaxon, (void) );
 
 #endif /* _PAGE_H_ */
--- parse.c	2001-10-10 15:55:18.000000000 -0400
+++ parse.c	2014-12-26 23:03:20.000000000 -0500
@@ -61,4 +61,6 @@
 
 #include <stdio.h>
+#include <stdlib.h>
+#include <unistd.h>
 #include <X11/Xlib.h>
 #include <X11/Xresource.h>
@@ -89,6 +91,4 @@
 
 extern 	Display *dpy;
-extern 	void exit ();
-extern 	char *getenv ();
 
 FCT (static char *, GetHomeDir, (char *dest) ); 
@@ -107,5 +107,4 @@ FCT (static void, Usage, () ); 
 
 static XrmOptionDescRec opTable [] = {
-  
   {"=",		"*geometry",	XrmoptionIsArg,		(caddr_t) 0 },
   {"-browsergeometry",	"*browsergeometry",	XrmoptionSepArg, (caddr_t) 0 },
@@ -157,5 +156,5 @@ void ParseOpenDisp ( argc, argv )
     char *str_type [10];
     char *displayname;
-    char buf [32];
+    char buf [64];
 
     char *cmd_name = strrchr ( *argv, '/' );
@@ -176,6 +175,5 @@ void ParseOpenDisp ( argc, argv )
      * Malheureusement il faut passer par un fichier intermediaire.
      */
-    bzero ( buf, 32 );
-    (void) sprintf ( buf, "/tmp/xcoral_db%d", getuid() );
+    (void) sprintf (buf, "/tmp/xcoral_db%ld", (long)getuid());
     XrmPutFileDatabase ( commandlineDB, buf );
     if ( (savecommandlineDB = XrmGetFileDatabase (  buf )) != 0 ) 
@@ -201,5 +199,5 @@ void ParseOpenDisp ( argc, argv )
     if ( XrmGetResource ( commandlineDB, "xcoral.display",
 			 "xcoral.display",	str_type, &value ) == True ) {
-	displayname = (char *) malloc ( (unsigned) (value.size + 1) );
+	displayname = malloc (value.size + 1);
 	bzero ( displayname, (int) (value.size + 1));
 	(void) strncpy ( displayname, value.addr, (int) value.size );
@@ -1017,5 +1015,5 @@ static void Usage ()
 unsigned long PixelValue ( display, str, result )
     Display *display;
-    char *str;
+    const char *str;
     int *result;
 {
--- parse.h	1995-02-22 08:03:39.000000000 -0500
+++ parse.h	2014-12-26 01:45:48.000000000 -0500
@@ -44,16 +44,16 @@
 #include "proto_decl.h"
 
-FCT (unsigned long, GetOpBD, () );
-FCT (unsigned int, GetOpBW, () );
+FCT (unsigned long, GetOpBD, (void) );
+FCT (unsigned int, GetOpBW, (void) );
 FCT (unsigned long, GetOpColor, (int type) );
-FCT (char *, GetOpFilename, () );
+FCT (char *, GetOpFilename, (void) );
 FCT (XFontStruct *, GetOpFont, (int type) );
 FCT (int, GetOpGeo, (int type) );
-FCT (void, GetUserDatabase, () );
-FCT (void, MergeOptions, () );
-FCT (int, OpVerbose, () );
+FCT (void, GetUserDatabase, (void) );
+FCT (void, MergeOptions, (void) );
+FCT (int, OpVerbose, (void) );
 FCT (void, ParseOpenDisp, (int *argc, char *argv[]) );
-FCT (unsigned long, PixelValue, (Display *dpy, char *str, int *result) );
-FCT (int, UseColor, () );
+FCT (unsigned long, PixelValue, (Display *dpy, const char *str, int *result) );
+FCT (int, UseColor, (void) );
 
 
--- proc_dict.c	2002-11-24 14:03:43.000000000 -0500
+++ proc_dict.c	2014-12-27 03:31:37.000000000 -0500
@@ -44,4 +44,5 @@
 #endif
 #include <stdio.h>
+#include <stdlib.h>
 
 #include "result_types.h"
@@ -65,7 +66,7 @@ int proc_count = 0;
 */
 ProcRec* create_proc(proc_name, staticp, parsed_file)
-    char* proc_name;
+    const char *proc_name;
     int staticp;
-    char * parsed_file;
+    const char *parsed_file;
 {
   ProcRec**  head;
@@ -99,5 +100,5 @@ ProcRec* create_proc(proc_name, staticp,
 */
 ProcRec* find_proc(proc_name)
-  char* proc_name;
+  const char* proc_name;
 {
   ProcRec**  head;
@@ -114,5 +115,5 @@ ProcRec* find_proc(proc_name)
 */
 void proc_eraze_file(file_name)
-    char * file_name;
+    const char * file_name;
 {
   FileRec * current_file;
--- proc_dict.h	2002-11-24 05:41:19.000000000 -0500
+++ proc_dict.h	2014-12-27 03:10:58.000000000 -0500
@@ -83,9 +83,11 @@ extern  int proc_count;
 */
 
-extern ProcRec*     create_proc   (/* char* proc_name */);
+extern ProcRec*     create_proc   (const char* proc_name, int staticp, const char *parsedfile);
 
-extern ProcRec*     find_proc     (/* char* proc_name */);
+extern ProcRec*     find_proc     (const char* proc_name);
 
-extern void proc_eraze_marked_files();
+extern void proc_eraze_file(const char * file_name);
+
+extern void proc_eraze_marked_files(void);
 
 #endif  /*  PROCDICT_H  */
--- process.c	2001-01-01 07:45:04.000000000 -0500
+++ process.c	2014-12-27 05:01:44.000000000 -0500
@@ -40,4 +40,5 @@
 
 #include <stdio.h>
+#include <unistd.h>
 #include <X11/Xlib.h>
 #include <X11/Xutil.h>
@@ -46,4 +47,5 @@
 #include <signal.h>
 #include <fcntl.h>
+#include <sys/wait.h>
 
 #if HAVE_STRING_H
@@ -117,7 +119,7 @@ void SetShellMode ( text )
     Text *text;
 {
-    int pid, c_pid;
-    char *shell;
-    
+    pid_t pid, c_pid;
+    const char *shell;
+ 
     if ( strcmp(text -> current_mode -> name, "Shell") != 0 ) {
 	text -> current_mode = (Mode *) GetMode ("Shell");
@@ -153,13 +155,12 @@ void SetShellMode ( text )
       (void) setpgrp ( c_pid, c_pid);
 #endif
-      shell = (char *) getenv("XCORAL_SHELL");
+      shell = getenv("XCORAL_SHELL");
       if (shell == NULL) {
-	shell = (char *) getenv("SHELL");
+	shell = getenv("SHELL");
 	if (shell == NULL) {
-	  shell = (char *) malloc(strlen("/bin/csh")+2);
-	  strcpy(shell,"/bin/csh");
+	  shell = "/bin/csh";
 	}
       }
-      (void) execlp (shell, shell, "-i", 0);
+      (void) execlp (shell, shell, "-i", NULL);
       (void) fprintf ( stderr, "Can't exec shell\n" );
       break;
@@ -217,5 +218,5 @@ void KillShell ( text )
 static void GetExitShell ()
 {
-    int pid;
+    pid_t pid;
     int statusp;
     EdWin **t;
--- process.h	1995-02-22 08:03:40.000000000 -0500
+++ process.h	2014-12-27 05:02:26.000000000 -0500
@@ -44,5 +44,5 @@
 #include "proto_decl.h"
 
-FCT (void, InitShellMode, () );
+FCT (void, InitShellMode, (void) );
 FCT (void, KillShell, (Text *text) );
 FCT (void, ReadFromShell, (Text *text) );
@@ -53,4 +53,5 @@ FCT (void, shell_CtrD, (Text *text) );
 FCT (void, shell_key, (Text *text) );
 FCT (void, shell_return, (Text *text) );
+FCT (void, CleanFd, (Text *text) );
 
 #endif /* _PROCESS_H_ */
--- regex.c	1997-04-15 02:54:31.000000000 -0400
+++ regex.c	2014-12-27 05:37:47.000000000 -0500
@@ -1626,9 +1626,10 @@ regex_compile (pattern, size, syntax, bu
               if (syntax & RE_NO_BK_PARENS) goto normal_backslash;
 
-              if (COMPILE_STACK_EMPTY)
+              if (COMPILE_STACK_EMPTY) {
                 if (syntax & RE_UNMATCHED_RIGHT_PAREN_ORD)
                   goto normal_backslash;
                 else
                   return REG_ERPAREN;
+              }
 
             handle_close:
@@ -1646,9 +1647,10 @@ regex_compile (pattern, size, syntax, bu
 
               /* See similar code for backslashed left paren above.  */
-              if (COMPILE_STACK_EMPTY)
+              if (COMPILE_STACK_EMPTY) {
                 if (syntax & RE_UNMATCHED_RIGHT_PAREN_ORD)
                   goto normal_char;
                 else
                   return REG_ERPAREN;
+              }
 
               /* Since we just checked for an empty stack above, this
@@ -2328,5 +2330,5 @@ typedef struct
    be called from within `PUSH_FAILURE_POINT'.  */
 #define PUSH_FAILURE_ITEM(item)						\
-  fail_stack.stack[fail_stack.avail++] = (fail_stack_elt_t) item
+  fail_stack.stack[fail_stack.avail++] = (fail_stack_elt_t)(intptr_t)item
 
 /* The complement operation.  Assumes `fail_stack' is nonempty.  */
@@ -2834,5 +2836,5 @@ re_set_registers (bufp, regs, num_regs, 
       bufp->regs_allocated = REGS_UNALLOCATED;
       regs->num_regs = 0;
-      regs->start = regs->end = (regoff_t) 0;
+      regs->start = regs->end = NULL;
     }
 }
@@ -4878,5 +4880,5 @@ size_t
 regerror (errcode, preg, errbuf, errbuf_size)
     int errcode;
-    regex_t *preg;
+    const regex_t *preg __attribute__((unused));
     char *errbuf;
     size_t errbuf_size;
--- regex.h	1996-09-04 07:12:57.000000000 -0400
+++ regex.h	2014-12-27 05:38:06.000000000 -0500
@@ -476,5 +476,5 @@ extern int regexec
              regmatch_t pmatch[], int eflags));
 extern size_t regerror
-  _RE_ARGS ((int errcode, regex_t *preg, char *errbuf,
+  _RE_ARGS ((int errcode, const regex_t *preg, char *errbuf,
              size_t errbuf_size));
 extern void regfree _RE_ARGS ((regex_t *preg));
--- result_types.h	1997-12-03 04:26:29.000000000 -0500
+++ result_types.h	2014-12-27 03:02:43.000000000 -0500
@@ -57,5 +57,5 @@ typedef int LineNumber;
 
 
-typedef char* StringTable[];
+typedef char** StringTable;
 
 
@@ -125,8 +125,8 @@ typedef struct Position Position;
 #define GET_METHOD_CLASS(pt)    (get_method_class(pt))
 
-extern char* get_method_class();
+extern const char* get_method_class(const char *method_name);
 
 #define GET_ATTRIBUTE_CLASS(pt)    (get_attribute_class(pt))
-extern char* get_attribute_class();
+extern const char* get_attribute_class(const char *class_name);
 
 #define HIDED(pt) ((pt)[-2] == 'H')
--- scroll.c	2003-02-05 07:58:53.000000000 -0500
+++ scroll.c	2014-12-26 01:52:34.000000000 -0500
@@ -56,4 +56,5 @@
 #include "parse.h"
 #include "buttons_bits.h"
+#include "tbox.h"
 
 static char gray [] = { 0x1, 0x02 };
@@ -127,5 +128,5 @@ void InitScroll ( display )
     
     if ((depth == 16)||(depth == 24)) {
-      sb_up_im = (XImage *)LoadImage256 ((char **) xpm_sb_up_bits);
+      sb_up_im = LoadImage256 (xpm_sb_up_bits);
       sb_up_pix = XCreatePixmap (display, DefaultRootWindow (display),
 				 SCROLL_BUTTONS_WIDTH, SCROLL_BUTTONS_HEIGHT, depth);
@@ -133,5 +134,5 @@ void InitScroll ( display )
 		 SCROLL_BUTTONS_WIDTH, SCROLL_BUTTONS_HEIGHT);
       
-      sb_down_im = (XImage *)LoadImage256 ((char **) xpm_sb_down_bits);
+      sb_down_im = LoadImage256 (xpm_sb_down_bits);
       sb_down_pix = XCreatePixmap (display, DefaultRootWindow (display),
 				   SCROLL_BUTTONS_WIDTH, SCROLL_BUTTONS_HEIGHT, depth);
@@ -139,5 +140,5 @@ void InitScroll ( display )
 		 SCROLL_BUTTONS_WIDTH, SCROLL_BUTTONS_HEIGHT);
 
-      sb_down_im_run = (XImage *)LoadImage256 ((char **) xpm_sb_down_bits_run);
+      sb_down_im_run = LoadImage256 (xpm_sb_down_bits_run);
       sb_down_pix_run = XCreatePixmap (display, DefaultRootWindow (display),
 				   SCROLL_BUTTONS_WIDTH, SCROLL_BUTTONS_HEIGHT, depth);
@@ -145,5 +146,5 @@ void InitScroll ( display )
 		 SCROLL_BUTTONS_WIDTH, SCROLL_BUTTONS_HEIGHT);
 
-      sb_up_im_run = (XImage *)LoadImage256 ((char **) xpm_sb_up_bits_run);
+      sb_up_im_run = LoadImage256 (xpm_sb_up_bits_run);
       sb_up_pix_run = XCreatePixmap (display, DefaultRootWindow (display),
 				 SCROLL_BUTTONS_WIDTH, SCROLL_BUTTONS_HEIGHT, depth);
@@ -152,5 +153,5 @@ void InitScroll ( display )
     }
     else {
-      sb_up_pix = 
+      sb_up_pix =
 	XCreatePixmapFromBitmapData ( display, root, (char *) sb_up_bits,
 				     SCROLL_BUTTONS_WIDTH, SCROLL_BUTTONS_HEIGHT,
--- scroll.h	2002-12-16 03:12:41.000000000 -0500
+++ scroll.h	2014-12-26 00:48:05.000000000 -0500
@@ -99,4 +99,6 @@ FCT (void, SetScrollBarSize, (Display *d
 FCT (void, SetScrollLine, (SWin *swin, int n) );
 FCT (void, ShowScrollFrame, (Display *display, SWin *s) );
+FCT (void, Display3DArrow, (SWin *, Window, int run) );
+
 
 #define SetScrollFont(s, f)	(s -> font = f)
--- selection.h	2001-01-06 06:58:16.000000000 -0500
+++ selection.h	2014-12-26 22:50:13.000000000 -0500
@@ -43,5 +43,5 @@
 #include "proto_decl.h"
 
-typedef struct _Selection {
+struct _Selection {
   int select;     /* Pour undiquer une selection */
   int start_line; /* Numero de la ligne ou commence la selection */
@@ -55,16 +55,19 @@ typedef struct _Selection {
   int s_sl;         /* Scroll horizontal au debut */
   int e_sl;         /* Scroll horizontal a la fin */
-} Selection;
+};
 
-extern void ClearSelection ();
-extern unsigned long HandleSelection ();
-extern void UpdateSelection ();
-extern void RefreshSelection ();
-extern void InitSelection();
-extern int SelectionIsVisible();
-extern void StartSelection();
-extern void EndSelection();
-extern void UpdateSelection();
-extern void ClearSelectionIfNeeded();
+typedef struct _Selection Selection;
+struct _Text;
 
-#endif /* _SELECTION_H_ */
+extern void ClearSelection(struct _Text *, int select);
+extern unsigned long HandleSelection(struct _Text *);
+extern void UpdateSelection(struct _Text *);
+extern void RefreshSelection(struct _Text *);
+extern void InitSelection(Display *, unsigned long fg, unsigned long bg);
+extern int SelectionIsVisible(const struct _Text *);
+extern void StartSelection(struct _Text *);
+extern void EndSelection(struct _Text *);
+extern void UpdateSelection(struct _Text *);
+extern void ClearSelectionIfNeeded(struct _Text *);
+
+#endif /* _SELECTION_H_ */
\ No newline at end of file
--- tbox.c	2008-01-09 11:49:25.000000000 -0500
+++ tbox.c	2014-12-27 05:46:18.000000000 -0500
@@ -39,4 +39,5 @@
 
 #include <stdio.h>
+#include <stdlib.h>
 #include <X11/Xlib.h>
 #include <X11/Xutil.h>
@@ -46,13 +47,14 @@
 #include "options.h" 
 #include "xc_conf.h" 
-#include "tbox.h" 
+#define DEFINE_BITMAPS
+#include "tbox.h"
+#include "parse.h"
+#include "main_events.h"
+#include "shadow.h"
 
 extern Display *dpy;
 static  Atom trombines_del;
-static  int display_tbox = True;
 
 XImage *image[3];
-XImage * LoadImage16 ();
-XImage * LoadImage256 ();
 
 int no_image = False;
@@ -79,5 +81,5 @@ void InitTrombinesBox() 
     XGCValues	 gcv;
     XSizeHints sizehints;
-    int visual_matched, i;
+    int visual_matched;
     
     black = BlackPixel ( dpy, DefaultScreen ( dpy ));
@@ -192,37 +194,13 @@ void InitTrombinesBox() 
 }
 
-int getDepth(unsigned long xx, int *max_value)
-{
-  unsigned long mask = xx; 
-  int i,j;
-
-  for(i=1;i<32;i++){
-    if ((mask & 1)==1) {
-      *max_value = mask+1;
-      for(i=1;i<16;i++){
-	mask = mask >> 1;
-	if(mask==0)
-	  break;
-      }
-      break;
-    }
-    mask = mask >> 1;
-  }
-  return i;
-}
-
 /* On affiche en noir et blanc */
-XImage * LoadImage16(char **xpm)
+XImage * LoadImage16(const char * const *xpm)
 {
   /* Pour les Sun et autres engins a 8 plans !!! on affiche en niveau de gris*/
   int wp, hp, ncp, ncpp; /* infos pixmap */
-  unsigned long *p;
   int i, j, index, dd;
-  char c1,c2,c3;
-  unsigned char rr, gg, bb;
+  char c1;
   XColor xcolor;
   rgb cm[1024];
-  rgb cm2[512];
-  rgb cm3[128];
   XImage *image;
   int depth;
@@ -240,13 +218,12 @@ XImage * LoadImage16(char **xpm)
   for (i=0;i<512;i++)cm[i].x = 0;
   for (i=1;i<(ncp+1);i++){ /* de 1 a 16*/
-    c1 = (char) ((char *)xpm[i])[0];
+    c1 = xpm[i][0];
     index = ((c1-7) * (c1-3)) % 507;
     if(cm[index].x == 0) {
       cm[index].x = 1;
-      strncpy (cm[index].rrggbb,(char *)(xpm[i]+5),6);
       cm[index].c1 = c1;
       
       /* recherche du niveau de gris, les 3 composantes ont le meme poids */
-      sscanf(((char *)(cm[index].rrggbb)),"%2X", &dd);
+      sscanf(xpm[i] + 5, "%2X", &dd);
       xcolor.red = (unsigned short)dd<<8;
       xcolor.green = (unsigned short)dd<<8;
@@ -265,5 +242,5 @@ XImage * LoadImage16(char **xpm)
 
   /* Cration de la structure pour l'image */
-  data = (char *) malloc (( wp * hp * 4 ));
+  data = malloc (( wp * hp * 4 ));
   bzero (data, (wp * hp * 4 ));
   
@@ -284,5 +261,5 @@ XImage * LoadImage16(char **xpm)
   for(i=0;i<hp;i++){
     for(j=0;j<wp;j++){
-      c1 = (char) (((char *)xpm[ncp+1+i])[j]);
+      c1 = xpm[ncp+1+i][j];
       index = ((c1-7) * (c1-3)) % 507;
       if(cm[index].c1 == c1){
@@ -321,17 +298,14 @@ unsigned long getPixelColor (unsigned ch
 }
 
-XImage * LoadImage256(char **xpm)
+XImage * LoadImage256(const char * const *xpm)
 {
     int wp, hp, ncp, ncpp; /* infos pixmap */
-    char c1,c2,c3;
-    unsigned char rr, gg, bb;
-    unsigned long *p;
-    int i, j, index, dd;
-    char buf[2];
-    XColor xcolor;
-    rgb cm[1024];
-    rgb cm2[512];
-    rgb cm3[128];
-    rgb cm4[256];
+    char c1,c2;
+    unsigned int rr, gg, bb;
+    int i, j, index;
+    rgb cm[1024] = { { 0 } };
+    rgb cm2[512] = { { 0 } };
+    rgb cm3[128] = { { 0 } };
+    rgb cm4[256] = { { 0 } };
     XImage * image;
     int depth;
@@ -348,29 +322,18 @@ XImage * LoadImage256(char **xpm)
   sscanf (xpm[0],"%d %d %d %d", &wp, &hp, &ncp, &ncpp);
   
-  for (i=0;i<1024;i++)cm[i].x = 0;      
-  for (i=0;i<512;i++)cm2[i].x = 0;      
-  for (i=0;i<128;i++)cm3[i].x = 0;      
-  for (i=0;i<256;i++)cm4[i].x = 0;      
   for (i=1;i<(ncp+1);i++){
-    rr = gg = bb = dd = 0;
-    c1 = (char) ((char *)xpm[i])[0];
-    c2 = (char) ((char *)xpm[i])[1];
+    rr = gg = bb = 0;
+    c1 = xpm[i][0];
+    c2 = xpm[i][1];
     index = ((c1-7) * (c2-3)) % 1007;
     if(cm[index].x == 0) {
       cm[index].x = 1;
-      if (((char)((char *)xpm[i])[5])=='N'){ /* (None. Pas de couleur */
+      if (xpm[i][5] == 'N'){ /* (None. Pas de couleur */
 	rr=gg=bb=0;
       }
       else {
-	strncpy (cm[index].rrggbb,(char *)(xpm[i]+6),6);
-	sscanf(((char *)(cm[index].rrggbb)),"%2X", &dd);
-	rr = (unsigned char) dd;
-	sscanf(((char *)(cm[index].rrggbb)+2),"%2X", &dd);
-	gg = (unsigned char) dd;
-	sscanf(((char *)(cm[index].rrggbb)+4),"%2X", &dd);
-	bb = (unsigned char) dd;
+	sscanf(xpm[i] + 6, "%2X%2X%2X", &rr, &gg, &bb);
       }
       cm[index].pixel = getPixelColor(rr,gg,bb);
-      cm[index].rrggbb[6]='\0';
       cm[index].c1 = c1;
       cm[index].c2 = c2;
@@ -380,13 +343,6 @@ XImage * LoadImage256(char **xpm)
       if(cm2[index].x == 0) {
 	cm2[index].x = 1;
-	strncpy (cm2[index].rrggbb,(char *)(xpm[i]+6),6);
-	sscanf(((char *)(cm2[index].rrggbb)),"%2X", &dd);
-	rr = (unsigned char) dd;
-	sscanf(((char *)(cm2[index].rrggbb)+2),"%2X", &dd);
-	gg = (unsigned char) dd;
-	sscanf(((char *)(cm2[index].rrggbb)+4),"%2X", &dd);
-	bb = (unsigned char) dd;
+	sscanf(xpm[i] + 6, "%2X%2X%2X", &rr, &gg, &bb);
 	cm2[index].pixel = getPixelColor(rr,gg,bb);
-	cm2[index].rrggbb[6]='\0';
 	cm2[index].c1 = c1;
 	cm2[index].c2 = c2;
@@ -396,13 +352,6 @@ XImage * LoadImage256(char **xpm)
 	if(cm3[index].x == 0) {
 	  cm3[index].x = 1;
-	  strncpy (cm3[index].rrggbb,(char *)(xpm[i]+6),6);
-	  sscanf(((char *)(cm3[index].rrggbb)),"%2X", &dd);
-	  rr = (unsigned char) dd;
-	  sscanf(((char *)(cm3[index].rrggbb)+2),"%2X", &dd);
-	  gg = (unsigned char) dd;
-	  sscanf(((char *)(cm3[index].rrggbb)+4),"%2X", &dd);
-	  bb = (unsigned char) dd;
+	  sscanf(xpm[i] + 6, "%2X%2X%2X", &rr, &gg, &bb);
 	  cm3[index].pixel = getPixelColor(rr,gg,bb);
- 	  cm3[index].rrggbb[6]='\0';
 	  cm3[index].c1 = c1;
 	  cm3[index].c2 = c2;
@@ -412,18 +361,11 @@ XImage * LoadImage256(char **xpm)
 	  if(cm4[index].x == 0) {
 	    cm4[index].x = 1;
-	    strncpy (cm4[index].rrggbb,(char *)(xpm[i]+6),6);
-	    sscanf(((char *)(cm4[index].rrggbb)),"%2X", &dd);
-	    rr = (unsigned char) dd;
-	    sscanf(((char *)(cm4[index].rrggbb)+2),"%2X", &dd);
-	    gg = (unsigned char) dd;
-	    sscanf(((char *)(cm4[index].rrggbb)+4),"%2X", &dd);
-	    bb = (unsigned char) dd;
+	    sscanf(xpm[i] + 6, "%2X%2X%2X", &rr, &gg, &bb);
 	    cm4[index].pixel = getPixelColor(rr,gg,bb);
-	    cm4[index].rrggbb[6]='\0';
 	    cm4[index].c1 = c1;
 	    cm4[index].c2 = c2;
 	  }
 	  else
-	    printf("brrr index = %d c1 = %d c2 = %d %s\n", index, c1, c2, cm[index].rrggbb);
+	    printf("brrr index = %d c1 = %d c2 = %d %s\n", index, c1, c2, xpm[i] + 6);
 	  }
       }
@@ -432,5 +374,5 @@ XImage * LoadImage256(char **xpm)
 
   /* Cration de la structure pour l'image */
-  data = (char *) malloc (( wp * hp * 4 ));
+  data = malloc (( wp * hp * 4 ));
   bzero (data, (wp * hp * 4 ));
   image = XCreateImage(dpy, 
@@ -449,6 +391,6 @@ XImage * LoadImage256(char **xpm)
   for(i=0;i<hp;i++){
     for(j=0;j<wp;j++){
-      c1 = (char) (((char *)xpm[ncp+1+i])[(2*j)]);
-      c2 = (char) (((char *)xpm[ncp+1+i])[(2*j)+1]);
+      c1 = xpm[ncp+1+i][2*j];
+      c2 = xpm[ncp+1+i][2*j + 1];
       index = ((c1-7) * (c2-3)) % 1007;
       if((cm[index].c1 == c1) && (cm[index].c2 == c2)) 
@@ -460,10 +402,8 @@ XImage * LoadImage256(char **xpm)
 	else {
 	  index = ((c1-7) * (c2-3)) % 119;
-	  if((cm3[index].c1 == c1) && (cm3[index].c2 == c2))
+	  if(index >= 0 && (cm3[index].c1 == c1) && (cm3[index].c2 == c2))
 	      XPutPixel (image, j, i, cm3[index].pixel);
-	  else {
-	    index = ((c1-7) * (c2-3)) % 201;
-	    XPutPixel (image, j, i, cm4[index].pixel);
-	  }
+	  else if ((index = ((c1-7) * (c2-3)) % 201) >= 0)
+	      XPutPixel (image, j, i, cm4[index].pixel);
 	}
       }
--- tbox.h	2001-04-21 19:48:46.000000000 -0400
+++ tbox.h	2014-12-26 00:13:45.000000000 -0500
@@ -10,5 +10,4 @@
 typedef struct _rgb {
   unsigned long pixel;
-  char rrggbb[7];
   char c1, c2;
   int x;
@@ -27,17 +26,20 @@ typedef struct _TBox {
 } TBox;
 TBox trombines_box;
-FCT (void, DisplayTrombines, () );
+FCT (void, DisplayTrombines, (void) );
 
 FCT (void, ConfigTrombinesBox, (int width, int height) );
-FCT (void, DisplayTrombines, () );
+FCT (void, DisplayTrombines, (void) );
 FCT (int, ExposeTrombinesBox, (XEvent *ev) );
-FCT (void, InitTrombinesBox, () );
+FCT (void, InitTrombinesBox, (void) );
 FCT (int, ButtonTrombinesBox, ( XButtonEvent * ev ));
+FCT (XImage *, LoadImage16, (const char * const *xpm));
+FCT (XImage *, LoadImage256, (const char * const *xpm));
 
 #define GetTrombinesBoxFrame() (trombines_box.frame)
 
 
+#ifdef DEFINE_BITMAPS
 /* XPM */
-static char *bp_16gray[] = {
+static const char *bp_16gray[] = {
 /* width height ncolors chars_per_pixel */
 "110 150 16 1",
@@ -212,5 +214,5 @@ static char *bp_16gray[] = {
 };
 /* XPM */
-static char *bp_256[] = {
+static const char *bp_256[] = {
 /* width height ncolors chars_per_pixel */
 "110 150 256 2",
@@ -625,5 +627,5 @@ static char *bp_256[] = {
 };
 /* XPM */
-static char *dl_16gray[] = {
+static const char *dl_16gray[] = {
 /* width height ncolors chars_per_pixel */
 "110 150 14 1",
@@ -796,5 +798,5 @@ static char *dl_16gray[] = {
 };
 /* XPM */
-static char *dl_256[] = {
+static const char *dl_256[] = {
 /* width height ncolors chars_per_pixel */
 "110 150 256 2",
@@ -1209,5 +1211,5 @@ static char *dl_256[] = {
 };
 /* XPM */
-static char *lf_16gray[] =
+static const char *lf_16gray[] =
 {
 /* width height ncolors chars_per_pixel */
@@ -1384,5 +1386,5 @@ static char *lf_16gray[] =
 
 /* XPM */
-static char *lf1_16gray[] = {
+static const char *lf1_16gray[] = {
 /* width height ncolors chars_per_pixel */
 "110 150 16 1",
@@ -1557,5 +1559,5 @@ static char *lf1_16gray[] = {
 };
 /* XPM */
-static char *lf_256[] = {
+static const char *lf_256[] = {
 /* width height num_colors chars_per_pixel */
 "110 150 249 2",
@@ -1964,5 +1966,5 @@ static char *lf_256[] = {
 
 /* XPM */
-static char *lf1_256[] = {
+static const char *lf1_256[] = {
 /* width height ncolors chars_per_pixel */
 "110 150 256 2",
@@ -2376,4 +2378,5 @@ static char *lf1_256[] = {
 ".b.).).e j < j j w j j j ; ; j.3X0X0.3.3.3 j j HX6X6.3.3X0 jX6 H j j.3Xm j.) jX%X%X%X% @X% @.q.q.q.qX%.qX% @X%X%X%X%X$.M.c <.bX4X4X4X4X4X6.3X6.3.3.3X6.3X0.3.3X0X6X6 ;X. H w w.c.M.e < < <.e.e.eX$X$.e < < < < <.M.c < <.I.I"
 };
+#endif
 
 #endif /* _TBOX_H_ */
